#ifdef HP1020
#include <dl.h>
#else
#include <dlfcn.h>
#endif

#include <stdio.h>

#include "lisptype.h"
#include "lispenvironment.h"
#include "lispplugin.h"
#include "lispassert.h"
#include "platdll.h"

LispInt ElfDll::Open(LispCharPtr aDllFile)
{
#ifdef HP1020
   handle=shl_load(aDllFile,BIND_NONFATAL,  0L);
#else
    handle = dlopen(aDllFile,RTLD_LAZY); 
#endif
    return (handle != NULL);
}

ElfDll::~ElfDll()
{
    if (handle)
#ifdef HP1020
        shl_unload((shl_t)handle);
#else
        dlclose(handle);
#endif
    handle = NULL;
}


LispPluginBase* ElfDll::GetPlugin(void)
{
    LISPASSERT(handle != NULL);
    LispPluginBase* (*maker)(void);
#ifdef HP1020
    maker = (LispPluginBase*(*)(void))shl_get((int)handle,(shl_descriptor **)"maker");
#else
    maker = (LispPluginBase*(*)(void))dlsym(handle,"maker");
#endif
    return maker();
}
